package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.DampakResikoConverter;
import com.jasamedika.medifirst2000.dao.DampakResikoDao;
import com.jasamedika.medifirst2000.entities.DampakResiko;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DampakResikoService;
import com.jasamedika.medifirst2000.vo.DampakResikoVO;

@Service("DampakResikoServiceImpl")
public class DampakResikoServiceImpl extends BaseVoServiceImpl implements DampakResikoService{

	@Autowired
	private DampakResikoDao dampakResikoDao;
	
	@Autowired
	private DampakResikoConverter dampakResikoConverter;
	
	@Override
	public DampakResikoVO add(DampakResikoVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public DampakResikoVO update(DampakResikoVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public DampakResikoVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<DampakResikoVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir,
			Specification<DampakResiko> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<DampakResiko> resultPage = dampakResikoDao.findAll(spec, pageable);
		List<DampakResiko> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(DampakResikoVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		DampakResiko model = dampakResikoConverter.transferVOToModel(vo, new DampakResiko());
		
		dampakResikoDao.save(model);
		
		return result;
	}

}
